// Code generated by go-swagger; DO NOT EDIT.

package exec_compat

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewExecStartParams creates a new ExecStartParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewExecStartParams() *ExecStartParams {
	return &ExecStartParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewExecStartParamsWithTimeout creates a new ExecStartParams object
// with the ability to set a timeout on a request.
func NewExecStartParamsWithTimeout(timeout time.Duration) *ExecStartParams {
	return &ExecStartParams{
		timeout: timeout,
	}
}

// NewExecStartParamsWithContext creates a new ExecStartParams object
// with the ability to set a context for a request.
func NewExecStartParamsWithContext(ctx context.Context) *ExecStartParams {
	return &ExecStartParams{
		Context: ctx,
	}
}

// NewExecStartParamsWithHTTPClient creates a new ExecStartParams object
// with the ability to set a custom HTTPClient for a request.
func NewExecStartParamsWithHTTPClient(client *http.Client) *ExecStartParams {
	return &ExecStartParams{
		HTTPClient: client,
	}
}

/*
ExecStartParams contains all the parameters to send to the API endpoint

	for the exec start operation.

	Typically these are written to a http.Request.
*/
type ExecStartParams struct {

	/* Control.

	   Attributes for start
	*/
	Control ExecStartBody

	/* ID.

	   Exec instance ID
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the exec start params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExecStartParams) WithDefaults() *ExecStartParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the exec start params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExecStartParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the exec start params
func (o *ExecStartParams) WithTimeout(timeout time.Duration) *ExecStartParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the exec start params
func (o *ExecStartParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the exec start params
func (o *ExecStartParams) WithContext(ctx context.Context) *ExecStartParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the exec start params
func (o *ExecStartParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the exec start params
func (o *ExecStartParams) WithHTTPClient(client *http.Client) *ExecStartParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the exec start params
func (o *ExecStartParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithControl adds the control to the exec start params
func (o *ExecStartParams) WithControl(control ExecStartBody) *ExecStartParams {
	o.SetControl(control)
	return o
}

// SetControl adds the control to the exec start params
func (o *ExecStartParams) SetControl(control ExecStartBody) {
	o.Control = control
}

// WithID adds the id to the exec start params
func (o *ExecStartParams) WithID(id string) *ExecStartParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the exec start params
func (o *ExecStartParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *ExecStartParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Control); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
