// Code generated by go-swagger; DO NOT EDIT.

package images_compat

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// ImageGetAllReader is a Reader for the ImageGetAll structure.
type ImageGetAllReader struct {
	formats strfmt.Registry
	writer  io.Writer
}

// ReadResponse reads a server response into the received o.
func (o *ImageGetAllReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImageGetAllOK(o.writer)
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 500:
		result := NewImageGetAllInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewImageGetAllOK creates a ImageGetAllOK with default headers values
func NewImageGetAllOK(writer io.Writer) *ImageGetAllOK {
	return &ImageGetAllOK{

		Payload: writer,
	}
}

/*
ImageGetAllOK describes a response with status code 200, with default header values.

no error
*/
type ImageGetAllOK struct {
	Payload io.Writer
}

// IsSuccess returns true when this image get all o k response has a 2xx status code
func (o *ImageGetAllOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this image get all o k response has a 3xx status code
func (o *ImageGetAllOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this image get all o k response has a 4xx status code
func (o *ImageGetAllOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this image get all o k response has a 5xx status code
func (o *ImageGetAllOK) IsServerError() bool {
	return false
}

// IsCode returns true when this image get all o k response a status code equal to that given
func (o *ImageGetAllOK) IsCode(code int) bool {
	return code == 200
}

func (o *ImageGetAllOK) Error() string {
	return fmt.Sprintf("[GET /images/get][%d] imageGetAllOK  %+v", 200, o.Payload)
}

func (o *ImageGetAllOK) String() string {
	return fmt.Sprintf("[GET /images/get][%d] imageGetAllOK  %+v", 200, o.Payload)
}

func (o *ImageGetAllOK) GetPayload() io.Writer {
	return o.Payload
}

func (o *ImageGetAllOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImageGetAllInternalServerError creates a ImageGetAllInternalServerError with default headers values
func NewImageGetAllInternalServerError() *ImageGetAllInternalServerError {
	return &ImageGetAllInternalServerError{}
}

/*
ImageGetAllInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type ImageGetAllInternalServerError struct {
	Payload *ImageGetAllInternalServerErrorBody
}

// IsSuccess returns true when this image get all internal server error response has a 2xx status code
func (o *ImageGetAllInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this image get all internal server error response has a 3xx status code
func (o *ImageGetAllInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this image get all internal server error response has a 4xx status code
func (o *ImageGetAllInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this image get all internal server error response has a 5xx status code
func (o *ImageGetAllInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this image get all internal server error response a status code equal to that given
func (o *ImageGetAllInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *ImageGetAllInternalServerError) Error() string {
	return fmt.Sprintf("[GET /images/get][%d] imageGetAllInternalServerError  %+v", 500, o.Payload)
}

func (o *ImageGetAllInternalServerError) String() string {
	return fmt.Sprintf("[GET /images/get][%d] imageGetAllInternalServerError  %+v", 500, o.Payload)
}

func (o *ImageGetAllInternalServerError) GetPayload() *ImageGetAllInternalServerErrorBody {
	return o.Payload
}

func (o *ImageGetAllInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ImageGetAllInternalServerErrorBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*
ImageGetAllInternalServerErrorBody image get all internal server error body
swagger:model ImageGetAllInternalServerErrorBody
*/
type ImageGetAllInternalServerErrorBody struct {

	// API root cause formatted for automated parsing
	// Example: API root cause
	Because string `json:"cause,omitempty"`

	// human error message, formatted for a human to read
	// Example: human error message
	Message string `json:"message,omitempty"`

	// http response code
	ResponseCode int64 `json:"response,omitempty"`
}

// Validate validates this image get all internal server error body
func (o *ImageGetAllInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this image get all internal server error body based on context it is used
func (o *ImageGetAllInternalServerErrorBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *ImageGetAllInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *ImageGetAllInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res ImageGetAllInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
