// Code generated by go-swagger; DO NOT EDIT.

package images_compat

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewImageHistoryParams creates a new ImageHistoryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewImageHistoryParams() *ImageHistoryParams {
	return &ImageHistoryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewImageHistoryParamsWithTimeout creates a new ImageHistoryParams object
// with the ability to set a timeout on a request.
func NewImageHistoryParamsWithTimeout(timeout time.Duration) *ImageHistoryParams {
	return &ImageHistoryParams{
		timeout: timeout,
	}
}

// NewImageHistoryParamsWithContext creates a new ImageHistoryParams object
// with the ability to set a context for a request.
func NewImageHistoryParamsWithContext(ctx context.Context) *ImageHistoryParams {
	return &ImageHistoryParams{
		Context: ctx,
	}
}

// NewImageHistoryParamsWithHTTPClient creates a new ImageHistoryParams object
// with the ability to set a custom HTTPClient for a request.
func NewImageHistoryParamsWithHTTPClient(client *http.Client) *ImageHistoryParams {
	return &ImageHistoryParams{
		HTTPClient: client,
	}
}

/*
ImageHistoryParams contains all the parameters to send to the API endpoint

	for the image history operation.

	Typically these are written to a http.Request.
*/
type ImageHistoryParams struct {

	/* Name.

	   the name or ID of the container
	*/
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the image history params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ImageHistoryParams) WithDefaults() *ImageHistoryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the image history params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ImageHistoryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the image history params
func (o *ImageHistoryParams) WithTimeout(timeout time.Duration) *ImageHistoryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the image history params
func (o *ImageHistoryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the image history params
func (o *ImageHistoryParams) WithContext(ctx context.Context) *ImageHistoryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the image history params
func (o *ImageHistoryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the image history params
func (o *ImageHistoryParams) WithHTTPClient(client *http.Client) *ImageHistoryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the image history params
func (o *ImageHistoryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the image history params
func (o *ImageHistoryParams) WithName(name string) *ImageHistoryParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the image history params
func (o *ImageHistoryParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *ImageHistoryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
