// Code generated by go-swagger; DO NOT EDIT.

package images_compat

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// ImagePruneReader is a Reader for the ImagePrune structure.
type ImagePruneReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ImagePruneReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImagePruneOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 500:
		result := NewImagePruneInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewImagePruneOK creates a ImagePruneOK with default headers values
func NewImagePruneOK() *ImagePruneOK {
	return &ImagePruneOK{}
}

/*
ImagePruneOK describes a response with status code 200, with default header values.

Delete response
*/
type ImagePruneOK struct {
	Payload []*ImagePruneOKBodyItems0
}

// IsSuccess returns true when this image prune o k response has a 2xx status code
func (o *ImagePruneOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this image prune o k response has a 3xx status code
func (o *ImagePruneOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this image prune o k response has a 4xx status code
func (o *ImagePruneOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this image prune o k response has a 5xx status code
func (o *ImagePruneOK) IsServerError() bool {
	return false
}

// IsCode returns true when this image prune o k response a status code equal to that given
func (o *ImagePruneOK) IsCode(code int) bool {
	return code == 200
}

func (o *ImagePruneOK) Error() string {
	return fmt.Sprintf("[POST /images/prune][%d] imagePruneOK  %+v", 200, o.Payload)
}

func (o *ImagePruneOK) String() string {
	return fmt.Sprintf("[POST /images/prune][%d] imagePruneOK  %+v", 200, o.Payload)
}

func (o *ImagePruneOK) GetPayload() []*ImagePruneOKBodyItems0 {
	return o.Payload
}

func (o *ImagePruneOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImagePruneInternalServerError creates a ImagePruneInternalServerError with default headers values
func NewImagePruneInternalServerError() *ImagePruneInternalServerError {
	return &ImagePruneInternalServerError{}
}

/*
ImagePruneInternalServerError describes a response with status code 500, with default header values.

Internal server error
*/
type ImagePruneInternalServerError struct {
	Payload *ImagePruneInternalServerErrorBody
}

// IsSuccess returns true when this image prune internal server error response has a 2xx status code
func (o *ImagePruneInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this image prune internal server error response has a 3xx status code
func (o *ImagePruneInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this image prune internal server error response has a 4xx status code
func (o *ImagePruneInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this image prune internal server error response has a 5xx status code
func (o *ImagePruneInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this image prune internal server error response a status code equal to that given
func (o *ImagePruneInternalServerError) IsCode(code int) bool {
	return code == 500
}

func (o *ImagePruneInternalServerError) Error() string {
	return fmt.Sprintf("[POST /images/prune][%d] imagePruneInternalServerError  %+v", 500, o.Payload)
}

func (o *ImagePruneInternalServerError) String() string {
	return fmt.Sprintf("[POST /images/prune][%d] imagePruneInternalServerError  %+v", 500, o.Payload)
}

func (o *ImagePruneInternalServerError) GetPayload() *ImagePruneInternalServerErrorBody {
	return o.Payload
}

func (o *ImagePruneInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(ImagePruneInternalServerErrorBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*
ImagePruneInternalServerErrorBody image prune internal server error body
swagger:model ImagePruneInternalServerErrorBody
*/
type ImagePruneInternalServerErrorBody struct {

	// API root cause formatted for automated parsing
	// Example: API root cause
	Because string `json:"cause,omitempty"`

	// human error message, formatted for a human to read
	// Example: human error message
	Message string `json:"message,omitempty"`

	// http response code
	ResponseCode int64 `json:"response,omitempty"`
}

// Validate validates this image prune internal server error body
func (o *ImagePruneInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this image prune internal server error body based on context it is used
func (o *ImagePruneInternalServerErrorBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *ImagePruneInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *ImagePruneInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res ImagePruneInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*
ImagePruneOKBodyItems0 image prune o k body items0
swagger:model ImagePruneOKBodyItems0
*/
type ImagePruneOKBodyItems0 struct {

	// deleted
	Deleted string `json:"deleted,omitempty"`

	// untagged
	Untagged []string `json:"untagged"`
}

// Validate validates this image prune o k body items0
func (o *ImagePruneOKBodyItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this image prune o k body items0 based on context it is used
func (o *ImagePruneOKBodyItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *ImagePruneOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *ImagePruneOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res ImagePruneOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
