// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// ContainerCgroupConfig ContainerCgroupConfig contains configuration information about a container's
// cgroups.
//
// swagger:model ContainerCgroupConfig
type ContainerCgroupConfig struct {

	// CgroupParent is the container's Cgroup parent.
	// If not set, the default for the current cgroup driver will be used.
	// Optional.
	CgroupParent string `json:"cgroup_parent,omitempty"`

	// CgroupsMode sets a policy for how cgroups will be created in the
	// container, including the ability to disable creation entirely.
	CgroupsMode string `json:"cgroups_mode,omitempty"`

	// cgroupns
	Cgroupns *Namespace `json:"cgroupns,omitempty"`
}

// Validate validates this container cgroup config
func (m *ContainerCgroupConfig) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCgroupns(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ContainerCgroupConfig) validateCgroupns(formats strfmt.Registry) error {
	if swag.IsZero(m.Cgroupns) { // not required
		return nil
	}

	if m.Cgroupns != nil {
		if err := m.Cgroupns.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cgroupns")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("cgroupns")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this container cgroup config based on the context it is used
func (m *ContainerCgroupConfig) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCgroupns(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ContainerCgroupConfig) contextValidateCgroupns(ctx context.Context, formats strfmt.Registry) error {

	if m.Cgroupns != nil {
		if err := m.Cgroupns.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cgroupns")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("cgroupns")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ContainerCgroupConfig) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ContainerCgroupConfig) UnmarshalBinary(b []byte) error {
	var res ContainerCgroupConfig
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
